//-->Light key- Toggle timer
//-->Right click- Detonate
//-->left Click- Hold to increase timer
//-->Hit bomb with a melee weapon to diffuse
datablock AudioDescription(C4Close3D: AudioClose3d)
{
	maxDistance = 100;
	referenceDistance = 100; //since you're overlapping sounds, it might be smart to start fading sounds very early, idk play around with it
};
datablock AudioDescription(C4Far3D: AudioClose3d)
{
	maxDistance = 900;
	referenceDistance = 100; //since you're overlapping sounds, it might be smart to start fading sounds very early, idk play around with it
};
datablock AudioProfile(C4Close)
{
   filename    = "./C4Close.wav";
   description = C4Close3d;
   preload = false;
};
datablock AudioProfile(C4Far)
{
   filename    = "./C4Far.wav";
   description = C4Far3d;
   preload = false;
};
datablock ParticleData(C4SmokeParticle)
{
  dragCoefficient = 3;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 15000;
  lifetimeVarianceMS = 0;
  textureName = "Add-ons/Weapon_C4Explosive/cloud1";
  spinSpeed = 0.0;
  spinRandomMin = -50.0;
  spinRandomMax = 50.0;
  colors[0] = "0.4 0.4 0.4 0.6";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 20;
  sizes[1] = 40;
  useInvAlpha = true;
};

datablock ParticleEmitterData(C4SmokeEmitter)
{
   uiName = "";
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1;
   ejectionOffset = 3;
   thetaMin = 89;
   thetaMax = 90;
   phiReferenceVel = 0;
   phiVariance = 360;
   overrideAdvance = false;
   particles = "C4SmokeParticle";
   emitterNode = TenthEmitterNode;
};

datablock ParticleData(C4ExplosionParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "Add-ons/Weapon_C4Explosive/cloud1";
  spinSpeed = 0;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 10;
  sizes[1] = 20;
  useInvAlpha = false;
};

datablock ParticleEmitterData(C4ExplosionEmitter)
{
  uiName = "";
  lifeTimeMS = 50;
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 3;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  particles = "C4ExplosionParticle";
};
AddDamageType("C4 ",   'C4  %1',    '%2 C4 %1',0.75,1);
datablock ExplosionData(C4Explosion)
{
  SoundProfile = C4Close;
  lifeTimeMS = 15000;
  particleEmitter = C4SmokeEmitter;
  particleDensity = 10;
  particleRadius = 0.2;
  emitter[0] = C4ExplosionEmitter;
  faceViewer = true;
  explosionScale = "0.4 0.4 0.4";
  shakeCamera = true;
  camShakeFreq = "10 10 10";
  camShakeAmp = "15 15 15";
  camShakeDuration = 0.5;
  camShakeRadius = 30;
  lightStartRadius = 10;
  lightEndRadius = 5;
  lightStartColor = "1 0.6 0.2 1";
  lightEndColor = "1 0 0 0";
  damageRadius = 15;
  radiusDamage = 500;
  impulseRadius = 12;
  impulseForce = 12;
};
datablock ProjectileData(C4Projectile)
{
  projectileShapeName = "./bullet.dts";
  directDamage = 500;
  brickExplosionRadius = 1;
  brickExplosionImpact = true;          //destroy a brick if we hit it directly?
  brickExplosionForce  = 50;             
  brickExplosionMaxVolume = 1000;          //max volume of bricks that we can destroy
  brickExplosionMaxVolumeFloating = 1000;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)
  ExplosionImpulse = 100;
  verticalImpulse = 100;
  explosion = C4Explosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 10;
  fadeDelay = 3000;
  bounceElasticity = 0.2;
  bounceFriction = 0.1;
  isBallistic = true;
  gravityMod = 0;
  explodeOnDeath = true;
  hasLight = false;
  lightRadius = 6;
  lightColor = "1 0.5 0";
};
exec("Add-ons/Weapon_C4Explosive/rotation.cs");
datablock ItemData(C4Item)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "Add-ons/Weapon_C4Explosive/HoldC4n.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	doColorShift = false;
	colorShiftColor = "51 51 51 1";
	image = C4Image;
	candrop = true;
	canPickup = true;
	uiName = "C4 Explosive";
	iconName = "Add-ons/Weapon_C4Explosive/icon_C4";
};
datablock ShapeBaseImageData(C4Image)
{
	shapeFile = "Add-ons/Weapon_C4Explosive/HoldC4n.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = "0 0 0";
	item = C4Item;
	doColorShift = false;
	colorShiftColor = "";
	armReady = true;
};
function GameConnection::C4Detonate(%client,%killer)
{
	ServerPlay3D(C4Far);
	if(!isObject(%client.c4))
		return;
	if(!%killer)
		%killer = %client;
	cancel(%client.c4tick);
	%pos = %client.c4.getTransform();
	%p = new Projectile()
	{
		dataBlock = C4Projectile;
		initialPosition  = %pos;
		client = %killer;
		sourceObject = %killer.player;
	};
	MissionCleanup.Add(%p);
	%client.c4Timer = 1;
	if(%client.c4.getClassName() $= "StaticShape")
		%client.c4.delete();
	else
		%client.c4 = "";
}
function C4Image::onMount(%this,%obj,%slot)
{
	%client = %obj.client;
	%client.c4timer = 1;
	%client.c4display = 1;
	%obj.playThread(0, armreadyboth);
	if(%client.c4mode $= "")
		%client.c4Mode = "timer";
	if(!isObject(%obj.client.c4))
	{
		if(%client.c4mode $= "timer")
			bottomprint(%client,"\c4C4 Mode:\c3 Countdown Timer<br>\c4Hold click to increase timer",5);
		else
			bottomprint(%client,"\c4C4 Mode:\c3 Remote Detonation<br>\c4Plant then right click to detonate",5);
	}
}
function C4Image::onUnMount(%this,%obj,%slot)
{
	%obj.playthread(0,Root);
	%client.c4timer = 1;
	%client.detTime = 0;
	if(!isObject(%obj.client.c4))
		commandtoclient(%obj.client,'clearbottomprint');
}
datablock StaticShapeData(C4Shape)
{
	shapeFile = "Add-ons/Weapon_C4Explosive/C4e.dts";
};
package C4
{
	function servercmdLight(%client)
	{
		if(!isObject(%client.player))
			return;
		if(%client.player.getMountedImage(0) $= nameToID("C4image"))
		{
			if(%client.c4timer $= "")
			{
				%client.c4timer = 1;
				return;
			}
			if(%client.c4timer == 0)
			{
				%client.c4timer = 1;
				commandtoclient(%client,'bottomprint',"\c4C4 Timer on.",4);
			}
			else
			{
				%client.c4timer = 0;
				commandtoclient(%client,'bottomprint',"\c4C4 Timer off.",4);
			}
			return;
		}
		Parent::servercmdLight(%client);
	}
	function ProjectileData::onCollision(%this,%obj,%col,%fade,%pos,%norm)
	{
		Parent::onCollision(%this,%obj,%col,%fade,%pos,%norm);
		if(%col.getClassName() !$= "StaticShape")
			return;
		if(%obj.client.minigame != %col.client.minigame)
			return;
		if(%col.getDatablock() $= nametoid("C4Shape"))
		{
			if(%obj.client.player.getMountedImage(0).melee != 1)
			{
				%col.client.C4Detonate(%obj.client);
				commandtoclient(%col.client,'clearbottomprint');
			}
			else
			{
				if(isEventPending(%col.client.c4tick))
				{
					%col.diffused = 1;
					commandtoclient(%col.client,'clearbottomprint');
					commandtoclient(%obj.client,'bottomprint',"\c4C4 bomb diffused.",2);
					cancel(%col.client.c4tick);
					%col.schedule(2000,delete);
				}
			}
			return;
		}
	}
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "C4item" && %col.canPickup)
		{
			for(%i=0;%i<%this.maxTools;%i++)
			{
				%item = %obj.tool[%i];
				if(%item $= 0 || %item $= "")
				{
					%freeSlot = 1;
					break;
				}
			}

			if(%freeSlot)
			{
				%obj.pickup(%col);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
	function GameConnection::onClientLeaveGame(%client)
	{
		if(isObject(%client.c4))
			%client.c4.delete();
		Parent::onClientLeaveGame(%client);
	}
	function GameConnection::onDeath(%this, %player, %killer, %damageType, %unknownA)
	{
		%this.c4display = 0;
		%this.c4candet = 0;
		if(isObject(%this.c4))
			Commandtoclient(%this,'clearbottomprint');
		parent::onDeath(%this, %player, %killer, %damageType, %unknownA);
	}
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 0 && %obj.getMountedImage(0) $= nameToID("C4image") && !isObject(%client.c4))
		{
			if(%val)
			{
				%client.clicking = 1;
				if(%client.C4Mode $= "timer")
				{
					if(isEventPending(%client.timerCountTick))
						cancel(%client.timerCountTick);
					%client.counting = 1;
					%client.countupTick();
				}
				else
					bottomprint(%client,"\c4C4 Mode:\c3 Remote Detonation<br>\c4Plant then right click to detonate",5);
			}
			if(!%val)
			{
				%client.clicking = 0;
				%client.counting = 0;
				if(%client.dettime == 0 && %client.c4Mode $= "timer")
					return;
				%wall = ContainerRayCast(%obj.getEyePoint(), VectorAdd(%obj.getEyePoint(), VectorScale(%obj.getEyeVector(), 10)),($TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::VehicleObjectType));
				if(isObject(%wall))
				{
					if(getword(%wall,0).getClassName() $= "FlyingVehicle" || getword(%wall,0).getClassName() $= "WheeledVehicle")
					{
						%client.c4 = getword(%wall,0);
						%currSlot = %obj.currtool;
						%obj.tool[%currSlot] = 0;
						%obj.weaponCount--;
						messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
						serverCmdUnUseTool(%obj.client);
						%obj.unMountImage(%slot);
						%client.schedule(1000,exCountDown,%client.detTime);
						%client.dettime = 0;
						CommandtoClient(%client,'BottomPrint',"\c4C4 planted in vehicle.",4);
						%client.c4display = 1;
						%client.c4candet = 1;
						return;
					}
					%currSlot = %obj.currtool;
					%obj.tool[%currSlot] = 0;
					%obj.weaponCount--;
					messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
					serverCmdUnUseTool(%obj.client);
					%obj.unMountImage(%slot);
					%client.c4 = new StaticShape()
					{
						datablock = C4Shape;
						client = %client;
						timer = %client.c4timer;
						mode = %client.c4mode;
					};
					%client.c4display = 1;
					%client.c4candet = 1;
					MissionCleanup.Add(%client.c4);
					%Hit = getwords(%wall,1,3);
					if(%client.c4mode $= "timer")
						%client.exCountDown(%client.detTime);
					else
						bottomprint(%client,"\c4C4 Mode:\c3 Remote Detonation<br>\c4Right click to detonate C4");
					%client.dettime = 0;
					%angle = getword(axisToEuler(getWords(%obj.getTransform(),3,6)),2);
					%angle = mFloor(%angle + 0.5);
					if(%angle < 0)
						%angle = %angle + 360;
					%direction = getword(roundAngle(%angle),1);
					%dir = getword(roundAngle(%angle),0);
					%trans = axisToEuler(getWords(%obj.getTransform(),3,6));
					%trans = setword(%trans,2,%direction);
					%trans = setword(%trans,0,90);
					
					%client.c4.setTransform(%hit SPC eulerToAxis(%trans));
					%found = ContainerRayCast(%client.c4.getPosition(),VectorAdd(%client.c4.getPosition(),"0 0 0.1"),($TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::VehicleObjectType));
					if(isObject(%found))
					{
						%trans = axisToEuler(getWords(%obj.getTransform(),3,6));
						%trans = setword(%trans,1,180);
						%trans = VectorSub(%hit,"0 0 0.15") SPC eulerToAxis(%trans);
						%client.c4.setTransform(%trans);
						return;
					}
					%found = ContainerRayCast(VectorAdd(%client.c4.getPosition(),"0 0 0.2"),VectorSub(%client.c4.getPosition(),"0 0 0.1"),($TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::VehicleObjectType));
					if(isObject(%found))
					{
						%client.c4.setTransform(VectorAdd(%hit,"0 0 0.15") SPC getwords(%obj.getTransform(),3,6));
						return;
					}
					if(%dir $= north)
						%client.c4.setTransform(VectorSub(%client.c4.getTransform(),"0 0.15"));
					if(%dir $= south)
						%client.c4.setTransform(VectorAdd(%client.c4.getTransform(),"0 0.15"));
					if(%dir $= east)
						%client.c4.setTransform(VectorSub(%client.c4.getTransform(),"0.15"));
					if(%dir $= west)
						%client.c4.setTransform(VectorAdd(%client.c4.getTransform(),"0.15"));
					return;
					
				}
				else
				{
					CommandtoClient(%client,'BottomPrint',"Failed to plant C4.",4);
					if(isEventPending(%client.timerCountTick))
						cancel(%client.timerCountTick);
					%client.timerCountTick = %client.schedule(1000,C4MsgCheck);
					%client.detTime = 0;
				}
			}
		}
		else if(%triggerNum == 4 && isObject(%client.c4) && %client.c4candet == 1)
		{
			if(%val)
			{
				%client.c4dtime = getsimtime();
			}
			else if(vectorDist(%client.c4dtime,getSimTime()) < 500 && %client.c4.diffused != 1 && %client.c4.mode $= "det")
			{
				%client.C4Detonate();
				commandtoclient(%client,'Bottomprint',"\c4Detonated C4.",4);
			}
		}
		else if(%triggerNum == 4 && !isObject(%client.c4) && %val && %obj.getMountedImage(0) $= nameToID("C4image"))
		{
			if(%client.c4Mode $= "timer")
			{
				if(isEventPending(%client.timerCountTick))
					cancel(%client.timerCountTick);
				bottomprint(%client,"\c4C4 Mode:\c3 Remote Detonation<br>\c4Plant then right click to detonate",5);
				%client.c4Mode = "det";
				%client.counting = 0;
				%client.detTime = 0;
				return;
			}
			else
			{
				bottomprint(%client,"\c4C4 Mode:\c3 Countdown Timer<br>\c4Hold click to increase timer",5);
				%client.c4Mode = "timer";
				%client.counting = 1;
				%client.detTime = 0;
				if(%client.clicking == 1)
					%client.countupTick();
				return;
			}
		}
		else if(%triggernum == 0 && %val)
		{
			Parent::onTrigger(%this, %obj, %triggerNum, %val);
			if(%obj.getMountedImage(0) != 0)
				return;
			%object = ContainerRayCast(%obj.getEyePoint(), VectorAdd(%obj.getEyePoint(), VectorScale(%obj.getEyeVector(), 10)),$TypeMasks::StaticObjectType);
			if(!isObject(%object))
				return;
			if(%object.getClassName() !$= "StaticShape" || %object.getDatablock() !$= nametoID("C4Shape"))
				return;
			if(%object.client == %client)
				return;
			if(%object.diffused == 1)
			{
				commandtoclient(%client,'Bottomprint',"\c4C4 bomb diffused.",3);
				return;
			}
			if(%object.mode $= "timer")
				CommandtoClient(%client,'BottomPrint',"\c4Time Remaining Until Detonation:\c3 " @ %object.timeleft,3);
			else
				CommandtoClient(%client,'BottomPrint',"\c4C4 Detonation Remote Activated",3);
			return;
		}
		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
if(isPackage(C4))
	deactivatePackage(C4);
ActivatePackage(C4);
function GameConnection::CountupTick(%client,%time)
{
	if(!%client.player || %client.counting != 1 || %client.player.getMountedImage(0) !$= nameToID("C4image"))
	{
		%client.counting = 0;
		return;
	}
	if(%time $= "")
		%time = 0;
	%time += 5;
	%client.detTime = %time;
	%minutes = %time / 60;
	%minutes = mfloor(%minutes);
	if(%minutes < 10)
		%minutes = 0 @ %minutes;
	%seconds = %time % 60;
	if(%seconds < 10)
		%seconds = 0 @ %seconds;
		bottomPrint(%client,"\c4C4 Mode:\c3 Countdown Timer<br>\c4Time Remaining Until Detonation:\c3 " @ %minutes @ ":" @ %seconds,4);
	%client.timerCountTick = %client.schedule(1000,CountUpTick,%time);
}
function GameConnection::ExCountDown(%client,%time,%AlTime,%mount)
{
	if(%Mount $= "")
	{
		%Mount = %client.c4;
	}
	if(!isObject(%Mount))
	{
		CommandtoClient(%client,'clearbottomprint');
		return;
	}
	if(%AlTime $= "")
	{
		%AlTime = 0;
	}
	if(%AlTime == %time && %Mount !$= "")
	{
		CommandtoClient(%client,'clearbottomprint');
		%client.C4Detonate();
		return;
	}
	if(%client.c4.timer == 1)
	{
		serverPlay3d("Synth_09_Sound",%Mount.getPosition());
	}
	%dis = %time - %Altime;
	%minutes = %dis / 60;
	%minutes = mfloor(%minutes);
	if(%minutes < 10)
		%minutes = 0 @ %minutes;
	%seconds = %dis % 60;
	if(%seconds < 10)
		%seconds = 0 @ %seconds;
	if(%client.c4display == 1)
		bottomprint(%client,"\c4C4 Mode: \c3Countdown Timer<br>\c4Time Remaining Until Detonation:\c3 " @ %minutes @ ":" @ %seconds,4);
	%client.c4.timeleft = %minutes @ ":" @ %seconds;	
	%AlTime++;
	%client.c4tick = %client.schedule(1000,exCountDown,%time,%altime,%mount);
}
function GameConnection::c4MsgCheck(%client)
{
	if(!isObject(%client.player))
		return;
	if(%client.player.getMountedImage(0) != nametoid("C4Image"))
		return;
	if(%client.c4mode $= "timer")
		bottomprint(%client,"\c4C4 Mode:\c3 Countdown Timer<br>\c4Hold click to increase timer",5);
	else
		bottomprint(%client,"\c4C4 Mode:\c3 Remote Detonation<br>\c4Plant then right click to detonate",5);
}
function roundAngle(%angle)
{
	if(%angle == 360)
		return "North 0";
	if(%angle >= 0 && %angle < 45)
		return "North 0";
	if(%angle >= 45 && %angle < 135)
		return "West 90";
	if(%angle >= 135 && %angle < 225)
		return "South 180";
	if(%angle >= 225 && %angle < 315)
		return "East 270";
	if(%angle >= 315 && %angle < 360)
		return "North 0";
	else
		return false;
}